Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# BamFile Class Reference

The principle public interface to reading and writing Bam disk files. More...

Inheritance diagram for BamFile:

List of all members.

## Public Member Functions
| BamFile ()
| close ()
| Closes the input or output stream.
int | getCurrentMajorVer ()
| Returns the system current major version number.
int | getCurrentMinorVer ()
| Returns the system current minor version number.
BamEndian | getFileEndian ()
| Returns the endian preference indicated by the Bam file currently being read or written.
int | getFileMajorVer ()
| Returns the major version number of the file currently being read, or the system current major version number if no file is currently open for reading.
int | getFileMinorVer ()
| Returns the minor version number of the file currently being read, or the system current minor version number if no file is currently open for reading.
bool | getFileStdfloatDouble ()
| Returns true if the file stores all "standard" floats as 64-bit doubles, or false if they are 32-bit floats.
BamReader | getReader ()
| Returns the BamReader in charge of performing the read operations.
BamWriter | getWriter ()
| Returns the BamWriter in charge of performing the write operations.
bool | isEof ()
| Returns true if the reader has reached end-of-file, false otherwise.
bool | isValidRead ()
| Returns true if the Bam file is open and ready for reading with no errors so far detected, or false otherwise.
bool | isValidWrite ()
| Returns true if the Bam file is open and ready for writing with no errors so far detected, or false otherwise.
bool | openRead (istream in, string bam_filename, bool report_errors)
| Attempts to open the indicated stream for reading.
bool | openRead (Filename const bam_filename, bool report_errors)
| Attempts to open the indicated filename for reading.
bool | openRead (istream in, string bam_filename)
| Attempts to open the indicated stream for reading.
bool | openRead (istream in)
| Attempts to open the indicated stream for reading.
bool | openRead (Filename const bam_filename)
| Attempts to open the indicated filename for reading.
bool | openWrite (ostream out, string bam_filename)
| Attempts to open the indicated stream for writing.
bool | openWrite (ostream out)
| Attempts to open the indicated stream for writing.
bool | openWrite (ostream out, string bam_filename, bool report_errors)
| Attempts to open the indicated stream for writing.
bool | openWrite (Filename const bam_filename)
| Attempts to open the indicated file for writing.
bool | openWrite (Filename const bam_filename, bool report_errors)
| Attempts to open the indicated file for writing.
PandaNode | readNode (bool report_errors)
| Although the bam file format is general enough to store a list of objects of arbitrary type, bam files on disk usually contain just one object, a PandaNode that is the root of a scene graph.
PandaNode | readNode ()
| Although the bam file format is general enough to store a list of objects of arbitrary type, bam files on disk usually contain just one object, a PandaNode that is the root of a scene graph.
TypedWritable | readObject ()
| Reads and returns the next object from the Bam file, or NULL if the end of the file has been reached, or if there is an error condition.
bool | resolve ()
| This must be called after one or more objects have been read via calls to read_object() in order to resolve all internal pointer references in the objects read and make all the pointers valid.
bool | writeObject (TypedWritable const object)
| Writes the indicated object to the Bam file.

## Detailed Description

The principle public interface to reading and writing Bam disk files.

See also BamReader and BamWriter, the more general implementation of this class.

Bam files are most often used to store scene graphs or subgraphs, and by convention they are given filenames ending in the extension ".bam" when they are used for this purpose. However, a Bam file may store any arbitrary list of TypedWritable objects; in this more general usage, they are given filenames ending in ".boo" to differentiate them from the more common scene graph files.

## Constructor & Destructor Documentation

BamFile | ( |  | ) |

## Member Function Documentation

close | ( |  | ) |

Closes the input or output stream.

int getCurrentMajorVer | ( |  | ) |

Returns the system current major version number.

This is the version number that will be assigned to any generated Bam files.

int getCurrentMinorVer | ( |  | ) |

Returns the system current minor version number.

This is the version number that will be assigned to any generated Bam files.

BamEndian getFileEndian | ( |  | ) |

Returns the endian preference indicated by the Bam file currently being read or written.

int getFileMajorVer | ( |  | ) |

Returns the major version number of the file currently being read, or the system current major version number if no file is currently open for reading.

int getFileMinorVer | ( |  | ) |

Returns the minor version number of the file currently being read, or the system current minor version number if no file is currently open for reading.

bool getFileStdfloatDouble | ( |  | ) |

Returns true if the file stores all "standard" floats as 64-bit doubles, or false if they are 32-bit floats.

BamReader getReader | ( |  | ) |

Returns the BamReader in charge of performing the read operations.

This will return NULL unless open_read() was called.

BamWriter getWriter | ( |  | ) |

Returns the BamWriter in charge of performing the write operations.

This will return NULL unless open_write() was called.

bool isEof | ( |  | ) |

Returns true if the reader has reached end-of-file, false otherwise.

This call is only valid after a call to read_object().

bool isValidRead | ( |  | ) |

Returns true if the Bam file is open and ready for reading with no errors so far detected, or false otherwise.

bool isValidWrite | ( |  | ) |

Returns true if the Bam file is open and ready for writing with no errors so far detected, or false otherwise.

bool openRead | ( | istream | in,
|  | string | bam_filename
| ) |  |

Attempts to open the indicated stream for reading.

The filename is just for information purposes only. Returns true if successful, false on error.

bool openRead | ( | Filename const | bam_filename | ) |

Attempts to open the indicated filename for reading.

Returns true if successful, false on error.

bool openRead | ( | istream | in | ) |

Attempts to open the indicated stream for reading.

The filename is just for information purposes only. Returns true if successful, false on error.

bool openRead | ( | Filename const | bam_filename,
|  | bool | report_errors
| ) |  |

Attempts to open the indicated filename for reading.

Returns true if successful, false on error.

bool openRead | ( | istream | in,
|  | string | bam_filename,
|  | bool | report_errors
| ) |  |

Attempts to open the indicated stream for reading.

The filename is just for information purposes only. Returns true if successful, false on error.

bool openWrite | ( | Filename const | bam_filename,
|  | bool | report_errors
| ) |  |

Attempts to open the indicated file for writing.

If another file by the same name already exists, it will be silently removed. Returns true if successful, false otherwise.

bool openWrite | ( | Filename const | bam_filename | ) |

Attempts to open the indicated file for writing.

If another file by the same name already exists, it will be silently removed. Returns true if successful, false otherwise.

bool openWrite | ( | ostream | out,
|  | string | bam_filename
| ) |  |

Attempts to open the indicated stream for writing.

The filename is just for information purposes only. Returns true if successful, false on error.

bool openWrite | ( | ostream | out | ) |

Attempts to open the indicated stream for writing.

The filename is just for information purposes only. Returns true if successful, false on error.

bool openWrite | ( | ostream | out,
|  | string | bam_filename,
|  | bool | report_errors
| ) |  |

Attempts to open the indicated stream for writing.

The filename is just for information purposes only. Returns true if successful, false on error.

PandaNode readNode | ( | bool | report_errors | ) |

Although the bam file format is general enough to store a list of objects of arbitrary type, bam files on disk usually contain just one object, a PandaNode that is the root of a scene graph.

(Bam files that store other kinds of things are usually given the extension "boo", for "binary other objects", to differentiate them from the normal scene graph type file.)

This is a convenience method for when you believe you are reading a scene graph bam file. It reads the one PandaNode and returns it. It also calls resolve() to fully resolve the object, since we expect this will be the only object in the file.

If the bam file contains something other than a PandaNode, an error is printed and NULL is returned.

PandaNode readNode | ( |  | ) |

Although the bam file format is general enough to store a list of objects of arbitrary type, bam files on disk usually contain just one object, a PandaNode that is the root of a scene graph.

(Bam files that store other kinds of things are usually given the extension "boo", for "binary other objects", to differentiate them from the normal scene graph type file.)

This is a convenience method for when you believe you are reading a scene graph bam file. It reads the one PandaNode and returns it. It also calls resolve() to fully resolve the object, since we expect this will be the only object in the file.

If the bam file contains something other than a PandaNode, an error is printed and NULL is returned.

TypedWritable readObject | ( |  | ) |

Reads and returns the next object from the Bam file, or NULL if the end of the file has been reached, or if there is an error condition.

Use is_eof() to differentiate these two cases.

The pointers returned by this method will not be valid for use until resolve() is subsequently called.

bool resolve | ( |  | ) |

This must be called after one or more objects have been read via calls to read_object() in order to resolve all internal pointer references in the objects read and make all the pointers valid.

It returns true if all objects are successfully resolved, or false if some have not been (in which case you must call resolve() again later).

bool writeObject | ( | TypedWritable const | object | ) |

Writes the indicated object to the Bam file.

Returns true if successful, false on error.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties